# Список изменений

## [2.0.0-rc.2]

### Исправления ошибок
- Исправлен запуск в Vue 2

### Улучшена обработка параметров

При работе на реальном проекте столкнулись с тем, что Яндекс очень скупо объяснял, что пошло не так, если вы не указали обязательный параметр в `settings`.

Чтобы исправить это, была улучшена документация и добавлена дополнительная обработка параметров компонентов:

#### Сделаны обязательными settings в компонентах

- YandexMapControls
- YandexMapFeatureDataSource
- YandexMapTileDataSource
- YandexMapLayer
- YandexMapDefaultMarker
- YandexMapMarker
- YandexMapFeature

Валидация будет проходить только на onMounted (перед подключением Яндекса) для случаев, когда настройки появляются позже, чем создаётся компонент.

#### Добавлена валидация обязательных параметров
- YandexMap: `location` (только изменён текст ошибки)
- YandexMapControls: `position`
- YandexMapFeatureDataSource: `id`
- YandexMapTileDataSource: `id`
- YandexMapLayer: `type`
- YandexMapDefaultMarker: `coordinates`
- YandexMapMarker: `coordinates`
- YandexMapFeature: `geometry`

### Типизация

- Из типизации YandexMapControlButton убран `text`

## [2.0.0-rc.1]

Версия перешла в состояние Release Candidate! Это значит, что библиотека:

- Полностью документирована, кроме Migration Guide
- Готова к тестированию на продуктиве
- Принимает тикеты с багами и пожеланиями
- Крупных breaking-изменений вноситься не будет

Просим принять максимальное участие в тестировании. Переход библиотеки в тэг latest планируется в январе-феврале.

### Документация

- Добавлен базовый Migration Guide
- Раздел "О проекте" дополнен информацией о планируемых сроках перехода библиотеки в стабильность и отличиях от прошлых версий

## [2.0.0-beta.10]

С этим релизом версия 2.0 подошла к статусу Release Candidate.

Библиотека стабильна, полностью документирована (кроме гайда миграции) и готова к работе и тестированию сообществом.

### Новые возможности

- В кластер добавлен параметр `clusterMarkerProps` для изменения параметров маркера слота кластера.
- Добавлен и экспортирован тип `YandexMapListenerSettings`

### Документация

- Добавлен раздел "Список компонентов"
- Документированы все компоненты 🎉

## [2.0.0-beta.9]

- Теперь структура в DOM **до** отрисовки соответствует структуре **после**, включая `width`, `height` и прочее. Это решит, в том числе, проблемы отрисовки на SSR, когда карта визуально появлялась только после отрисовки, из-за чего вся страница прыгала

Т.е. до:

```html

<div id="__app">
  <div class="__ymap_container" style="width:100%;height:100%;"></div>
</div>

```

После:

```html

<div id="__app">
  <div class="__ymap" style="width:50dvw;height:75dvh;color:#000;position:relative;z-index:0;">
    <div class="__ymap_container" style="width:100%;height:100%;"></div>
    <div class="__ymap_slots" style="display:none;"></div>
  </div>
</div>

```

## [2.0.0-beta.8]

### Исправления ошибок

- Исправлена работа реактивности циферок кластеров
- Исправлен случайный фатальный краш при отрисовке кластеров
- Исправлена ошибка, при которой библиотека иногда могла не работать в Nuxt 3

### Документация

- Завершена работа над секцией "Примеры". Добавлены последние примеры: Элементы управления и Хинты.

## [2.0.0-beta.7]

В этой сборке были внедрены улучшения производительности. Что-то могло сломаться, в частности - реактивность.

### Кластер

- Параметр слота `clustererObject` переименован в `clusterer`
- ЗНАЧИТЕЛЬНО улучшена производительность. Убраны костыли, поддержано кэширование Яндекса

### Исправления ошибок

- Исправлена ошибка, при которой содержимое попапа `YandexMapDefaultMarker` могло закрыться без действия пользователя, когда содержимое попапа было передано через слот `#popup`
- Исправлена ошибка, при которой всегда триггерилось обновление `settings` компонента, если в нём была функция, даже если она не менялась
- Исправлена ошибка, при которой default marker любил закрываться при клике куда угодно, кроме него
- Внедрено поведение, при котором изменение объекта первого уровня в `settings` приведет к полной передаче этого объекта в Яндекс.  
  Это сделано во избежание ситуаций, когда Яндекс требует полный набор данных, а передастся лишь кусок.  
  Вы могли это заметить при изменении `location.center` - если изменился только один элемент массива, Яндексу передавался только он, хотя требовался полный массив

### Типизация

- Экспортирован тип `YandexMapDefaultMarkerSettings` с настройками маркера
- Тип `VueYandexMapClustererOptions` переименован в `YandexMapClustererOptions`
- Из типизации удалены `vuefy` и `reactify` - их подключение бесполезно в данной библиотеке, кроме того, Яндекс сломали `Overload` **нашей** библиотеки бесконечной рекурсией, добавив `vuefy`

### Техническое

- Из `dependencies` удалён `rollup-plugin-copy`, попавший туда по ошибке
- Пакет обновлён до Vite 5

### Документация

- Добавлены примеры:
    - Попапы
    - Прямоугольник
    - Скрывать маркеры вне вьюпорта
- Документированы внутренние настройки `setupMapChildren`

## [2.0.0-beta.6]

### Исправления ошибок

- Теперь отслеживается лишь изменение в реактивных settings у всех компонентов - не только у `YandexMap`
- Исправлен краш с RangeError при использовании кластера в Vue 2

### Техническое

- Переработана сборка Nuxt 3/Bridge
- Доработана типизация настроек Nuxt 3/Bridge
- Переработаны импорты на `import/export type` и включён `verbatimModuleSyntax` в `tsconfig`

### Документация

- Добавлены примеры:
    - Добавление метки на карту
    - Перетаскивание объектов
    - Добавление метки с собственным изображением
    - Многоугольник
    - Ломаная

## [2.0.0-beta.5]

### Новые возможности

- Добавлена передача `coordinates` в слот `YandexMapClusterer`
- Добавлено изменение `zoom` для `realSettingsLocation`

### Исправления ошибок

- Доработан кластеризатор

### Документация

- Добавлена песочница
- Добавлен пример "Множество точек"

## [2.0.0-beta.4]

### Исправления ошибок

- Исправлен запуск в Vue 2, в котором не установлен `vue-demi`

### Документация

Добавлены примеры:

- Кастомные тайлы на Canvas
- Собственная карта
- Изменить размер карты
- Поместите в скрытый контейнер
- Ограничить область просмотра карты

## [2.0.0-beta.3]

- В npm добавлены README.md, LICENSE и CHANGELOG.md

## [2.0.0-beta.2]

### Breaking Changes

- Из сборки был удален плагин для Babel
- Из настроек `YandexMap` убран `projection`

### Новые возможности

- Поддержана реактивность `settings` в `YandexMap`
- Добавлены настройки `YandexMap`: `readonlySettings` и `realSettingsLocation`
- Добавлен экспортов локальных типов настроек из компонентов

### Документация

- Добавлен пример "Изменить положение камеры"
- Добавлен навбар

## [2.0.0-beta.1]

Начальный релиз
